<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css"
        integrity="sha512-iecdLmaskl7CVkqkXNQ/ZH/XLlvWZOJyj7Yy7tcenmpD1ypASozpmT/E0iPtmFIB46ZmdtAc9eNBvH0H/ZpiBw=="
        crossorigin="anonymous" referrerpolicy="no-referrer" />
    <!-- Import DataTable Library -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css">
    <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/datatables.net-bs4/3.2.2/dataTables.bootstrap4.min.js"
        integrity="sha512-zjnVNy8zmH0JujmJgrADeEjpVIrafOQm2iQSbKk5dAiUBa18xYI2035PpojcvHKLKgDHPUdA3FoxneTC/RooGw=="
        crossorigin="anonymous" referrerpolicy="no-referrer">
        </script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/datatables/1.10.21/js/jquery.dataTables.min.js"
        integrity="sha512-BkpSL20WETFylMrcirBahHfSnY++H2O1W+UnEEO4yNIl+jI2+zowyoGJpbtk6bx97fBXf++WJHSSK2MV4ghPcg=="
        crossorigin="anonymous" referrerpolicy="no-referrer">
        </script>
</head>

<body>
    <div class="container">
        <div class="text-center mt-2 mb-2">
            <h2>F200 - LỊCH SỬ VOUCHER</h2>
        </div>
        <div class="jumbotron container">
            <h2>Thông tin người chơi:</h2>
            <div class="row form-group mt-4">
                <div class="col-sm-4">
                    <div class="row align-items-center">
                        <div class="col-sm-4">
                            <label class="h5" for="ip-user-name">Username</label>
                        </div>
                        <div class="col-sm-8">
                            <input class="form-control btn-info" id="ip-user-name" type="text">
                        </div>
                    </div>
                </div>
                <div class="col-sm-4">
                    <div class="row align-items-center">
                        <div class="col-sm-4">
                            <label class="h5" for="ip-first-name">Firstname</label>
                        </div>
                        <div class="col-sm-8">
                            <input class="form-control btn-info" id="ip-first-name" type="text">
                        </div>
                    </div>
                </div>
                <div class="col-sm-4">
                    <div class="row align-items-center">
                        <div class="col-sm-4">
                            <label class="h5" for="ip-last-name">Lastname</label>
                        </div>
                        <div class="col-sm-8">
                            <input class="form-control btn-info" id="ip-last-name" type="text">
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="mt-5" id="log-result">

        </div>
        <div class="container">
            <table class="table table-bordered table-striped table-hover" id="dice-table">
                <thead>
                    <tr class="btn-primary">
                        <th>STT</th>
                        <th>Mã voucher</th>
                        <th>Phần trăm giảm giá</th>
                        <th>Ngày tạo</th>
                    </tr>
                </thead>
            </table>
        </div>
        <script>
            /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
            const gbaseUrl = "http://203.171.20.210:8080/devcamp-lucky-dice";
            var gPlayInfoObj = {};
            var gDiceHistoryData = [];
            var gSTT = 1;

            var gVoucher = ["stt", "maVoucher", "phanTramGiamGia", "ngayTao"];
            const gSTT_COL = 0;
            const gMA_VOUCHER_COL = 1;
            const gDISCOUNT_COL = 2;
            const gNGAY_TAO_COL = 3;

            var vPlayerDataTable = $("#dice-table").DataTable({
                columns: [
                    { data: gVoucher[gSTT_COL] },
                    { data: gVoucher[gMA_VOUCHER_COL] },
                    { data: gVoucher[gDISCOUNT_COL] },
                    { data: gVoucher[gNGAY_TAO_COL] },
                ],
                columnDefs: [
                    {
                        targets: gSTT_COL,
                        class: "text-center",
                        render: function () {
                            return gSTT++;
                        }
                    },
                    {
                        targets: gDISCOUNT_COL,
                        class: "text-center",
                        render: function (paramData) {
                            return paramData + "%";
                        }
                    },
                ]
            })
            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoad();
            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            function onPageLoad() {
                var vCurrenUrl = window.location.href;
                catchDataFromUrl(vCurrenUrl);
                loadPlayInfoToform(gPlayInfoObj);
                getPlayerVoucherHistory(gPlayInfoObj)
            }
            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
            function catchDataFromUrl(paramCurrenUrl) {
                var vNewUrl = new URL(paramCurrenUrl);

                gPlayInfoObj.username = vNewUrl.searchParams.get("user_name");
                gPlayInfoObj.firstname = vNewUrl.searchParams.get("first_name");
                gPlayInfoObj.lastname = vNewUrl.searchParams.get("last_name");

                console.log(gPlayInfoObj)
            }

            function loadPlayInfoToform(pamraPlayInfoObj) {
                $("#ip-user-name").val(pamraPlayInfoObj.username);
                $("#ip-first-name").val(pamraPlayInfoObj.firstname);
                $("#ip-last-name").val(pamraPlayInfoObj.lastname);
            }

            function getPlayerVoucherHistory(paramPlayInfoObj) {
                $.ajax({
                    url: gbaseUrl + "/voucher-history?username=" + paramPlayInfoObj.username,
                    type: "get",
                    success: function (paramVoucherHistory) {
                        console.log(paramVoucherHistory);
                        loadDataToDiceTable(paramVoucherHistory.vouchers);
                        $("#dice-table_info").html(`Có ${paramVoucherHistory.vouchers.length} bản ghi thõa mãn!`)
                    },
                    error: function (paramErr) {
                        console.log(paramErr.status);
                    }
                })
            }

            function loadDataToDiceTable(paramData) {
                console.log(paramData);
                vPlayerDataTable.clear();
                vPlayerDataTable.rows.add(paramData);
                vPlayerDataTable.draw();
            }
        </script>

</html>